
/*
 * This file was automatically generated by sdbus-c++-xml2cpp; DO NOT EDIT!
 */

#ifndef __sdbuscpp__dbuscallmanager_adaptor_h__adaptor__H__
#define __sdbuscpp__dbuscallmanager_adaptor_h__adaptor__H__

#include <sdbus-c++/sdbus-c++.h>
#include <string>
#include <tuple>

namespace cx {
namespace ring {
namespace Ring {

class CallManager_adaptor
{
public:
    static constexpr const char* INTERFACE_NAME = "cx.ring.Ring.CallManager";

protected:
    CallManager_adaptor(sdbus::IObject& object)
        : object_(object)
    {
        object_.registerMethod("placeCall").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "to").withOutputParamNames("callId").implementedAs([this](const std::string& accountId, const std::string& to){ return this->placeCall(accountId, to); });
        object_.registerMethod("placeCallWithMedia").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "to", "mediaList").withOutputParamNames("callId").implementedAs([this](const std::string& accountId, const std::string& to, const std::vector<std::map<std::string, std::string>>& mediaList){ return this->placeCallWithMedia(accountId, to, mediaList); });
        object_.registerMethod("requestMediaChange").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "callId", "mediaList").withOutputParamNames("requestMediaChangeSucceeded").implementedAs([this](const std::string& accountId, const std::string& callId, const std::vector<std::map<std::string, std::string>>& mediaList){ return this->requestMediaChange(accountId, callId, mediaList); });
        object_.registerMethod("refuse").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "callId").withOutputParamNames("refuseSucceeded").implementedAs([this](const std::string& accountId, const std::string& callId){ return this->refuse(accountId, callId); });
        object_.registerMethod("accept").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "callId").withOutputParamNames("acceptSucceeded").implementedAs([this](const std::string& accountId, const std::string& callId){ return this->accept(accountId, callId); });
        object_.registerMethod("acceptWithMedia").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "callId", "mediaList").withOutputParamNames("acceptSucceeded").implementedAs([this](const std::string& accountId, const std::string& callId, const std::vector<std::map<std::string, std::string>>& mediaList){ return this->acceptWithMedia(accountId, callId, mediaList); });
        object_.registerMethod("answerMediaChangeRequest").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "callId", "mediaList").withOutputParamNames("answerMediaChangeRequestSucceeded").implementedAs([this](const std::string& accountId, const std::string& callId, const std::vector<std::map<std::string, std::string>>& mediaList){ return this->answerMediaChangeRequest(accountId, callId, mediaList); });
        object_.registerMethod("hangUp").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "callId").withOutputParamNames("hangupSucceeded").implementedAs([this](const std::string& accountId, const std::string& callId){ return this->hangUp(accountId, callId); });
        object_.registerMethod("hangUpConference").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "confID").withOutputParamNames("hangupSucceeded").implementedAs([this](const std::string& accountId, const std::string& confID){ return this->hangUpConference(accountId, confID); });
        object_.registerMethod("hold").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "callId").withOutputParamNames("holdSucceeded").implementedAs([this](const std::string& accountId, const std::string& callId){ return this->hold(accountId, callId); });
        object_.registerMethod("unhold").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "callId").withOutputParamNames("unHoldSucceeded").implementedAs([this](const std::string& accountId, const std::string& callId){ return this->unhold(accountId, callId); });
        object_.registerMethod("muteLocalMedia").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "callid", "mediaType", "mute").withOutputParamNames("res").implementedAs([this](const std::string& accountId, const std::string& callid, const std::string& mediaType, const bool& mute){ return this->muteLocalMedia(accountId, callid, mediaType, mute); });
        object_.registerMethod("transfer").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "callId", "to").withOutputParamNames("transferSucceeded").implementedAs([this](const std::string& accountId, const std::string& callId, const std::string& to){ return this->transfer(accountId, callId, to); });
        object_.registerMethod("attendedTransfer").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "transferID", "targetID").withOutputParamNames("transferSucceeded").implementedAs([this](const std::string& accountId, const std::string& transferID, const std::string& targetID){ return this->attendedTransfer(accountId, transferID, targetID); });
        object_.registerMethod("playDTMF").onInterface(INTERFACE_NAME).withInputParamNames("key").implementedAs([this](const std::string& key){ return this->playDTMF(key); });
        object_.registerMethod("startTone").onInterface(INTERFACE_NAME).withInputParamNames("start", "type").implementedAs([this](const int32_t& start, const int32_t& type){ return this->startTone(start, type); });
        object_.registerMethod("joinParticipant").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "sel_callId", "account2Id", "drag_callId").withOutputParamNames("joinSucceeded").implementedAs([this](const std::string& accountId, const std::string& sel_callId, const std::string& account2Id, const std::string& drag_callId){ return this->joinParticipant(accountId, sel_callId, account2Id, drag_callId); });
        object_.registerMethod("createConfFromParticipantList").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "participants").implementedAs([this](const std::string& accountId, const std::vector<std::string>& participants){ return this->createConfFromParticipantList(accountId, participants); });
        object_.registerMethod("setConferenceLayout").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "confId", "layout").implementedAs([this](const std::string& accountId, const std::string& confId, const uint32_t& layout){ return this->setConferenceLayout(accountId, confId, layout); });
        object_.registerMethod("setActiveParticipant").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "confId", "callId").implementedAs([this](const std::string& accountId, const std::string& confId, const std::string& callId){ return this->setActiveParticipant(accountId, confId, callId); });
        object_.registerMethod("setActiveStream").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "confId", "accountUri", "deviceId", "streamId", "state").implementedAs([this](const std::string& accountId, const std::string& confId, const std::string& accountUri, const std::string& deviceId, const std::string& streamId, const bool& state){ return this->setActiveStream(accountId, confId, accountUri, deviceId, streamId, state); });
        object_.registerMethod("setModerator").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "confId", "peerId", "state").implementedAs([this](const std::string& accountId, const std::string& confId, const std::string& peerId, const bool& state){ return this->setModerator(accountId, confId, peerId, state); });
        object_.registerMethod("muteParticipant").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "confId", "peerId", "state").implementedAs([this](const std::string& accountId, const std::string& confId, const std::string& peerId, const bool& state){ return this->muteParticipant(accountId, confId, peerId, state); });
        object_.registerMethod("muteStream").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "confId", "accountUri", "deviceId", "streamId", "state").implementedAs([this](const std::string& accountId, const std::string& confId, const std::string& accountUri, const std::string& deviceId, const std::string& streamId, const bool& state){ return this->muteStream(accountId, confId, accountUri, deviceId, streamId, state); });
        object_.registerMethod("isConferenceParticipant").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "callId").withOutputParamNames("isParticipant").implementedAs([this](const std::string& accountId, const std::string& callId){ return this->isConferenceParticipant(accountId, callId); });
        object_.registerMethod("raiseParticipantHand").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "confId", "peerId", "state").implementedAs([this](const std::string& accountId, const std::string& confId, const std::string& peerId, const bool& state){ return this->raiseParticipantHand(accountId, confId, peerId, state); });
        object_.registerMethod("raiseHand").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "confId", "accountUri", "deviceId", "state").implementedAs([this](const std::string& accountId, const std::string& confId, const std::string& accountUri, const std::string& deviceId, const bool& state){ return this->raiseHand(accountId, confId, accountUri, deviceId, state); });
        object_.registerMethod("hangupParticipant").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "confId", "peerId", "deviceId").implementedAs([this](const std::string& accountId, const std::string& confId, const std::string& peerId, const std::string& deviceId){ return this->hangupParticipant(accountId, confId, peerId, deviceId); });
        object_.registerMethod("addParticipant").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "callId", "account2Id", "confID").withOutputParamNames("addSucceeded").implementedAs([this](const std::string& accountId, const std::string& callId, const std::string& account2Id, const std::string& confID){ return this->addParticipant(accountId, callId, account2Id, confID); });
        object_.registerMethod("addMainParticipant").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "confID").withOutputParamNames("addSucceeded").implementedAs([this](const std::string& accountId, const std::string& confID){ return this->addMainParticipant(accountId, confID); });
        object_.registerMethod("detachLocalParticipant").onInterface(INTERFACE_NAME).withOutputParamNames("detachSucceeded").implementedAs([this](){ return this->detachLocalParticipant(); });
        object_.registerMethod("detachParticipant").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "callId").withOutputParamNames("detachSucceeded").implementedAs([this](const std::string& accountId, const std::string& callId){ return this->detachParticipant(accountId, callId); });
        object_.registerMethod("joinConference").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "sel_confID", "account2Id", "drag_confID").withOutputParamNames("joinSucceeded").implementedAs([this](const std::string& accountId, const std::string& sel_confID, const std::string& account2Id, const std::string& drag_confID){ return this->joinConference(accountId, sel_confID, account2Id, drag_confID); });
        object_.registerMethod("getConferenceDetails").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "confId").withOutputParamNames("infos").implementedAs([this](const std::string& accountId, const std::string& confId){ return this->getConferenceDetails(accountId, confId); });
        object_.registerMethod("getConferenceList").onInterface(INTERFACE_NAME).withInputParamNames("accountId").withOutputParamNames("list").implementedAs([this](const std::string& accountId){ return this->getConferenceList(accountId); });
        object_.registerMethod("getConferenceId").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "callId").withOutputParamNames("confID").implementedAs([this](const std::string& accountId, const std::string& callId){ return this->getConferenceId(accountId, callId); });
        object_.registerMethod("toggleRecording").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "callId").withOutputParamNames("isRecording").implementedAs([this](const std::string& accountId, const std::string& callId){ return this->toggleRecording(accountId, callId); });
        object_.registerMethod("startSmartInfo").onInterface(INTERFACE_NAME).withInputParamNames("refreshTimeMs").implementedAs([this](const uint32_t& refreshTimeMs){ return this->startSmartInfo(refreshTimeMs); });
        object_.registerMethod("stopSmartInfo").onInterface(INTERFACE_NAME).implementedAs([this](){ return this->stopSmartInfo(); });
        object_.registerMethod("getIsRecording").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "callId").withOutputParamNames("isRecording").implementedAs([this](const std::string& accountId, const std::string& callId){ return this->getIsRecording(accountId, callId); });
        object_.registerMethod("recordPlaybackSeek").onInterface(INTERFACE_NAME).withInputParamNames("value").implementedAs([this](const double& value){ return this->recordPlaybackSeek(value); });
        object_.registerMethod("getCallDetails").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "callId").withOutputParamNames("infos").implementedAs([this](const std::string& accountId, const std::string& callId){ return this->getCallDetails(accountId, callId); });
        object_.registerMethod("getCallList").onInterface(INTERFACE_NAME).withInputParamNames("accountId").withOutputParamNames("list").implementedAs([this](const std::string& accountId){ return this->getCallList(accountId); });
        object_.registerMethod("switchInput").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "callId", "input").withOutputParamNames("arg0").implementedAs([this](const std::string& accountId, const std::string& callId, const std::string& input){ return this->switchInput(accountId, callId, input); });
        object_.registerMethod("switchSecondaryInput").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "conferenceId", "input").withOutputParamNames("arg0").implementedAs([this](const std::string& accountId, const std::string& conferenceId, const std::string& input){ return this->switchSecondaryInput(accountId, conferenceId, input); });
        object_.registerMethod("sendTextMessage").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "callId", "payloads", "isMixed").implementedAs([this](const std::string& accountId, const std::string& callId, const std::map<std::string, std::string>& payloads, const bool& isMixed){ return this->sendTextMessage(accountId, callId, payloads, isMixed); });
        object_.registerMethod("getConferenceInfos").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "confId").withOutputParamNames("arg0").implementedAs([this](const std::string& accountId, const std::string& confId){ return this->getConferenceInfos(accountId, confId); });
        object_.registerMethod("getParticipantList").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "confID").withOutputParamNames("list").implementedAs([this](const std::string& accountId, const std::string& confID){ return this->getParticipantList(accountId, confID); });
        object_.registerMethod("holdConference").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "confID").withOutputParamNames("holdSucceeded").implementedAs([this](const std::string& accountId, const std::string& confID){ return this->holdConference(accountId, confID); });
        object_.registerMethod("unholdConference").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "confID").withOutputParamNames("unholdSucceeded").implementedAs([this](const std::string& accountId, const std::string& confID){ return this->unholdConference(accountId, confID); });
        object_.registerMethod("startRecordedFilePlayback").onInterface(INTERFACE_NAME).withInputParamNames("filepath").withOutputParamNames("result").implementedAs([this](const std::string& filepath){ return this->startRecordedFilePlayback(filepath); });
        object_.registerMethod("stopRecordedFilePlayback").onInterface(INTERFACE_NAME).implementedAs([this](){ return this->stopRecordedFilePlayback(); });
        object_.registerMethod("currentMediaList").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "callId").withOutputParamNames("mediaList").implementedAs([this](const std::string& accountId, const std::string& callId){ return this->currentMediaList(accountId, callId); });
        object_.registerSignal("SmartInfo").onInterface(INTERFACE_NAME).withParameters<std::map<std::string, std::string>>("info");
        object_.registerSignal("recordPlaybackFilepath").onInterface(INTERFACE_NAME).withParameters<std::string, std::string>("callId", "filepath");
        object_.registerSignal("recordPlaybackStopped").onInterface(INTERFACE_NAME).withParameters<std::string>("filepath");
        object_.registerSignal("updatePlaybackScale").onInterface(INTERFACE_NAME).withParameters<std::string, int32_t, int32_t>("filepath", "position", "size");
        object_.registerSignal("incomingCall").onInterface(INTERFACE_NAME).withParameters<std::string, std::string, std::string>("accountId", "callId", "from");
        object_.registerSignal("incomingCallWithMedia").onInterface(INTERFACE_NAME).withParameters<std::string, std::string, std::string, std::vector<std::map<std::string, std::string>>>("accountId", "callId", "from", "mediaList");
        object_.registerSignal("mediaChangeRequested").onInterface(INTERFACE_NAME).withParameters<std::string, std::string, std::vector<std::map<std::string, std::string>>>("accountId", "callId", "mediaList");
        object_.registerSignal("incomingMessage").onInterface(INTERFACE_NAME).withParameters<std::string, std::string, std::string, std::map<std::string, std::string>>("accountId", "callId", "from", "messages");
        object_.registerSignal("callStateChanged").onInterface(INTERFACE_NAME).withParameters<std::string, std::string, std::string, int32_t>("accountId", "callId", "state", "code");
        object_.registerSignal("conferenceChanged").onInterface(INTERFACE_NAME).withParameters<std::string, std::string, std::string>("accountId", "confId", "state");
        object_.registerSignal("conferenceCreated").onInterface(INTERFACE_NAME).withParameters<std::string, std::string>("accountId", "confID");
        object_.registerSignal("conferenceRemoved").onInterface(INTERFACE_NAME).withParameters<std::string, std::string>("accountId", "confId");
        object_.registerSignal("voiceMailNotify").onInterface(INTERFACE_NAME).withParameters<std::string, int32_t, int32_t, int32_t>("accountId", "newCount", "oldCount", "urgentCount");
        object_.registerSignal("transferSucceeded").onInterface(INTERFACE_NAME);
        object_.registerSignal("transferFailed").onInterface(INTERFACE_NAME);
        object_.registerSignal("recordingStateChanged").onInterface(INTERFACE_NAME).withParameters<std::string, bool>("callId", "recordingState");
        object_.registerSignal("onRtcpReportReceived").onInterface(INTERFACE_NAME).withParameters<std::string, std::map<std::string, int32_t>>("callId", "report");
        object_.registerSignal("peerHold").onInterface(INTERFACE_NAME).withParameters<std::string, bool>("callId", "peerHolding");
        object_.registerSignal("audioMuted").onInterface(INTERFACE_NAME).withParameters<std::string, bool>("callId", "audioMuted");
        object_.registerSignal("videoMuted").onInterface(INTERFACE_NAME).withParameters<std::string, bool>("callId", "videoMuted");
        object_.registerSignal("onConferenceInfosUpdated").onInterface(INTERFACE_NAME).withParameters<std::string, std::vector<std::map<std::string, std::string>>>("confId", "infos");
        object_.registerSignal("remoteRecordingChanged").onInterface(INTERFACE_NAME).withParameters<std::string, std::string, bool>("callId", "peerNumber", "remoteRecordingState");
        object_.registerSignal("mediaNegotiationStatus").onInterface(INTERFACE_NAME).withParameters<std::string, std::string, std::vector<std::map<std::string, std::string>>>("callId", "event", "mediaList");
    }

    ~CallManager_adaptor() = default;

public:
    void emitSmartInfo(const std::map<std::string, std::string>& info)
    {
        object_.emitSignal("SmartInfo").onInterface(INTERFACE_NAME).withArguments(info);
    }

    void emitRecordPlaybackFilepath(const std::string& callId, const std::string& filepath)
    {
        object_.emitSignal("recordPlaybackFilepath").onInterface(INTERFACE_NAME).withArguments(callId, filepath);
    }

    void emitRecordPlaybackStopped(const std::string& filepath)
    {
        object_.emitSignal("recordPlaybackStopped").onInterface(INTERFACE_NAME).withArguments(filepath);
    }

    void emitUpdatePlaybackScale(const std::string& filepath, const int32_t& position, const int32_t& size)
    {
        object_.emitSignal("updatePlaybackScale").onInterface(INTERFACE_NAME).withArguments(filepath, position, size);
    }

    void emitIncomingCall(const std::string& accountId, const std::string& callId, const std::string& from)
    {
        object_.emitSignal("incomingCall").onInterface(INTERFACE_NAME).withArguments(accountId, callId, from);
    }

    void emitIncomingCallWithMedia(const std::string& accountId, const std::string& callId, const std::string& from, const std::vector<std::map<std::string, std::string>>& mediaList)
    {
        object_.emitSignal("incomingCallWithMedia").onInterface(INTERFACE_NAME).withArguments(accountId, callId, from, mediaList);
    }

    void emitMediaChangeRequested(const std::string& accountId, const std::string& callId, const std::vector<std::map<std::string, std::string>>& mediaList)
    {
        object_.emitSignal("mediaChangeRequested").onInterface(INTERFACE_NAME).withArguments(accountId, callId, mediaList);
    }

    void emitIncomingMessage(const std::string& accountId, const std::string& callId, const std::string& from, const std::map<std::string, std::string>& messages)
    {
        object_.emitSignal("incomingMessage").onInterface(INTERFACE_NAME).withArguments(accountId, callId, from, messages);
    }

    void emitCallStateChanged(const std::string& accountId, const std::string& callId, const std::string& state, const int32_t& code)
    {
        object_.emitSignal("callStateChanged").onInterface(INTERFACE_NAME).withArguments(accountId, callId, state, code);
    }

    void emitConferenceChanged(const std::string& accountId, const std::string& confId, const std::string& state)
    {
        object_.emitSignal("conferenceChanged").onInterface(INTERFACE_NAME).withArguments(accountId, confId, state);
    }

    void emitConferenceCreated(const std::string& accountId, const std::string& confID)
    {
        object_.emitSignal("conferenceCreated").onInterface(INTERFACE_NAME).withArguments(accountId, confID);
    }

    void emitConferenceRemoved(const std::string& accountId, const std::string& confId)
    {
        object_.emitSignal("conferenceRemoved").onInterface(INTERFACE_NAME).withArguments(accountId, confId);
    }

    void emitVoiceMailNotify(const std::string& accountId, const int32_t& newCount, const int32_t& oldCount, const int32_t& urgentCount)
    {
        object_.emitSignal("voiceMailNotify").onInterface(INTERFACE_NAME).withArguments(accountId, newCount, oldCount, urgentCount);
    }

    void emitTransferSucceeded()
    {
        object_.emitSignal("transferSucceeded").onInterface(INTERFACE_NAME);
    }

    void emitTransferFailed()
    {
        object_.emitSignal("transferFailed").onInterface(INTERFACE_NAME);
    }

    void emitRecordingStateChanged(const std::string& callId, const bool& recordingState)
    {
        object_.emitSignal("recordingStateChanged").onInterface(INTERFACE_NAME).withArguments(callId, recordingState);
    }

    void emitOnRtcpReportReceived(const std::string& callId, const std::map<std::string, int32_t>& report)
    {
        object_.emitSignal("onRtcpReportReceived").onInterface(INTERFACE_NAME).withArguments(callId, report);
    }

    void emitPeerHold(const std::string& callId, const bool& peerHolding)
    {
        object_.emitSignal("peerHold").onInterface(INTERFACE_NAME).withArguments(callId, peerHolding);
    }

    void emitAudioMuted(const std::string& callId, const bool& audioMuted)
    {
        object_.emitSignal("audioMuted").onInterface(INTERFACE_NAME).withArguments(callId, audioMuted);
    }

    void emitVideoMuted(const std::string& callId, const bool& videoMuted)
    {
        object_.emitSignal("videoMuted").onInterface(INTERFACE_NAME).withArguments(callId, videoMuted);
    }

    void emitOnConferenceInfosUpdated(const std::string& confId, const std::vector<std::map<std::string, std::string>>& infos)
    {
        object_.emitSignal("onConferenceInfosUpdated").onInterface(INTERFACE_NAME).withArguments(confId, infos);
    }

    void emitRemoteRecordingChanged(const std::string& callId, const std::string& peerNumber, const bool& remoteRecordingState)
    {
        object_.emitSignal("remoteRecordingChanged").onInterface(INTERFACE_NAME).withArguments(callId, peerNumber, remoteRecordingState);
    }

    void emitMediaNegotiationStatus(const std::string& callId, const std::string& event, const std::vector<std::map<std::string, std::string>>& mediaList)
    {
        object_.emitSignal("mediaNegotiationStatus").onInterface(INTERFACE_NAME).withArguments(callId, event, mediaList);
    }

private:
    virtual std::string placeCall(const std::string& accountId, const std::string& to) = 0;
    virtual std::string placeCallWithMedia(const std::string& accountId, const std::string& to, const std::vector<std::map<std::string, std::string>>& mediaList) = 0;
    virtual bool requestMediaChange(const std::string& accountId, const std::string& callId, const std::vector<std::map<std::string, std::string>>& mediaList) = 0;
    virtual bool refuse(const std::string& accountId, const std::string& callId) = 0;
    virtual bool accept(const std::string& accountId, const std::string& callId) = 0;
    virtual bool acceptWithMedia(const std::string& accountId, const std::string& callId, const std::vector<std::map<std::string, std::string>>& mediaList) = 0;
    virtual bool answerMediaChangeRequest(const std::string& accountId, const std::string& callId, const std::vector<std::map<std::string, std::string>>& mediaList) = 0;
    virtual bool hangUp(const std::string& accountId, const std::string& callId) = 0;
    virtual bool hangUpConference(const std::string& accountId, const std::string& confID) = 0;
    virtual bool hold(const std::string& accountId, const std::string& callId) = 0;
    virtual bool unhold(const std::string& accountId, const std::string& callId) = 0;
    virtual bool muteLocalMedia(const std::string& accountId, const std::string& callid, const std::string& mediaType, const bool& mute) = 0;
    virtual bool transfer(const std::string& accountId, const std::string& callId, const std::string& to) = 0;
    virtual bool attendedTransfer(const std::string& accountId, const std::string& transferID, const std::string& targetID) = 0;
    virtual void playDTMF(const std::string& key) = 0;
    virtual void startTone(const int32_t& start, const int32_t& type) = 0;
    virtual bool joinParticipant(const std::string& accountId, const std::string& sel_callId, const std::string& account2Id, const std::string& drag_callId) = 0;
    virtual void createConfFromParticipantList(const std::string& accountId, const std::vector<std::string>& participants) = 0;
    virtual void setConferenceLayout(const std::string& accountId, const std::string& confId, const uint32_t& layout) = 0;
    virtual void setActiveParticipant(const std::string& accountId, const std::string& confId, const std::string& callId) = 0;
    virtual void setActiveStream(const std::string& accountId, const std::string& confId, const std::string& accountUri, const std::string& deviceId, const std::string& streamId, const bool& state) = 0;
    virtual void setModerator(const std::string& accountId, const std::string& confId, const std::string& peerId, const bool& state) = 0;
    virtual void muteParticipant(const std::string& accountId, const std::string& confId, const std::string& peerId, const bool& state) = 0;
    virtual void muteStream(const std::string& accountId, const std::string& confId, const std::string& accountUri, const std::string& deviceId, const std::string& streamId, const bool& state) = 0;
    virtual bool isConferenceParticipant(const std::string& accountId, const std::string& callId) = 0;
    virtual void raiseParticipantHand(const std::string& accountId, const std::string& confId, const std::string& peerId, const bool& state) = 0;
    virtual void raiseHand(const std::string& accountId, const std::string& confId, const std::string& accountUri, const std::string& deviceId, const bool& state) = 0;
    virtual void hangupParticipant(const std::string& accountId, const std::string& confId, const std::string& peerId, const std::string& deviceId) = 0;
    virtual bool addParticipant(const std::string& accountId, const std::string& callId, const std::string& account2Id, const std::string& confID) = 0;
    virtual bool addMainParticipant(const std::string& accountId, const std::string& confID) = 0;
    virtual bool detachLocalParticipant() = 0;
    virtual bool detachParticipant(const std::string& accountId, const std::string& callId) = 0;
    virtual bool joinConference(const std::string& accountId, const std::string& sel_confID, const std::string& account2Id, const std::string& drag_confID) = 0;
    virtual std::map<std::string, std::string> getConferenceDetails(const std::string& accountId, const std::string& confId) = 0;
    virtual std::vector<std::string> getConferenceList(const std::string& accountId) = 0;
    virtual std::string getConferenceId(const std::string& accountId, const std::string& callId) = 0;
    virtual bool toggleRecording(const std::string& accountId, const std::string& callId) = 0;
    virtual void startSmartInfo(const uint32_t& refreshTimeMs) = 0;
    virtual void stopSmartInfo() = 0;
    virtual bool getIsRecording(const std::string& accountId, const std::string& callId) = 0;
    virtual void recordPlaybackSeek(const double& value) = 0;
    virtual std::map<std::string, std::string> getCallDetails(const std::string& accountId, const std::string& callId) = 0;
    virtual std::vector<std::string> getCallList(const std::string& accountId) = 0;
    virtual bool switchInput(const std::string& accountId, const std::string& callId, const std::string& input) = 0;
    virtual bool switchSecondaryInput(const std::string& accountId, const std::string& conferenceId, const std::string& input) = 0;
    virtual void sendTextMessage(const std::string& accountId, const std::string& callId, const std::map<std::string, std::string>& payloads, const bool& isMixed) = 0;
    virtual std::vector<std::map<std::string, std::string>> getConferenceInfos(const std::string& accountId, const std::string& confId) = 0;
    virtual std::vector<std::string> getParticipantList(const std::string& accountId, const std::string& confID) = 0;
    virtual bool holdConference(const std::string& accountId, const std::string& confID) = 0;
    virtual bool unholdConference(const std::string& accountId, const std::string& confID) = 0;
    virtual bool startRecordedFilePlayback(const std::string& filepath) = 0;
    virtual void stopRecordedFilePlayback() = 0;
    virtual std::vector<std::map<std::string, std::string>> currentMediaList(const std::string& accountId, const std::string& callId) = 0;

private:
    sdbus::IObject& object_;
};

}}} // namespaces

#endif
