
/*
 * This file was automatically generated by sdbus-c++-xml2cpp; DO NOT EDIT!
 */

#ifndef __sdbuscpp__dbusconfigurationmanager_adaptor_h__adaptor__H__
#define __sdbuscpp__dbusconfigurationmanager_adaptor_h__adaptor__H__

#include <sdbus-c++/sdbus-c++.h>
#include <string>
#include <tuple>

namespace cx {
namespace ring {
namespace Ring {

class ConfigurationManager_adaptor
{
public:
    static constexpr const char* INTERFACE_NAME = "cx.ring.Ring.ConfigurationManager";

protected:
    ConfigurationManager_adaptor(sdbus::IObject& object)
        : object_(object)
    {
        object_.registerMethod("getAccountTemplate").onInterface(INTERFACE_NAME).withInputParamNames("accountType").withOutputParamNames("details").implementedAs([this](const std::string& accountType){ return this->getAccountTemplate(accountType); });
        object_.registerMethod("getAccountDetails").onInterface(INTERFACE_NAME).withInputParamNames("accountID").withOutputParamNames("details").implementedAs([this](const std::string& accountID){ return this->getAccountDetails(accountID); });
        object_.registerMethod("getVolatileAccountDetails").onInterface(INTERFACE_NAME).withInputParamNames("accountID").withOutputParamNames("details").implementedAs([this](const std::string& accountID){ return this->getVolatileAccountDetails(accountID); });
        object_.registerMethod("setAccountDetails").onInterface(INTERFACE_NAME).withInputParamNames("accountID", "details").implementedAs([this](const std::string& accountID, const std::map<std::string, std::string>& details){ return this->setAccountDetails(accountID, details); });
        object_.registerMethod("setAccountActive").onInterface(INTERFACE_NAME).withInputParamNames("accountID", "enable").implementedAs([this](const std::string& accountID, const bool& enable){ return this->setAccountActive(accountID, enable); });
        object_.registerMethod("setCredentials").onInterface(INTERFACE_NAME).withInputParamNames("accountID", "credentialInformation").implementedAs([this](const std::string& accountID, const std::vector<std::map<std::string, std::string>>& credentialInformation){ return this->setCredentials(accountID, credentialInformation); });
        object_.registerMethod("getCredentials").onInterface(INTERFACE_NAME).withInputParamNames("accountID").withOutputParamNames("credentialInformation").implementedAs([this](const std::string& accountID){ return this->getCredentials(accountID); });
        object_.registerMethod("addAccount").onInterface(INTERFACE_NAME).withInputParamNames("details").withOutputParamNames("createdAccountId").implementedAs([this](const std::map<std::string, std::string>& details){ return this->addAccount(details); });
        object_.registerMethod("exportOnRing").onInterface(INTERFACE_NAME).withInputParamNames("accountID", "password").withOutputParamNames("success").implementedAs([this](const std::string& accountID, const std::string& password){ return this->exportOnRing(accountID, password); });
        object_.registerMethod("exportToFile").onInterface(INTERFACE_NAME).withInputParamNames("accountID", "destinationPath", "password").withOutputParamNames("success").implementedAs([this](const std::string& accountID, const std::string& destinationPath, const std::string& password){ return this->exportToFile(accountID, destinationPath, password); });
        object_.registerMethod("revokeDevice").onInterface(INTERFACE_NAME).withInputParamNames("accountID", "password", "deviceId").withOutputParamNames("success").implementedAs([this](const std::string& accountID, const std::string& password, const std::string& deviceId){ return this->revokeDevice(accountID, password, deviceId); });
        object_.registerMethod("getKnownRingDevices").onInterface(INTERFACE_NAME).withInputParamNames("accountID").withOutputParamNames("devices").implementedAs([this](const std::string& accountID){ return this->getKnownRingDevices(accountID); });
        object_.registerMethod("changeAccountPassword").onInterface(INTERFACE_NAME).withInputParamNames("accountID", "oldPassword", "newPassword").withOutputParamNames("success").implementedAs([this](const std::string& accountID, const std::string& oldPassword, const std::string& newPassword){ return this->changeAccountPassword(accountID, oldPassword, newPassword); });
        object_.registerMethod("lookupName").onInterface(INTERFACE_NAME).withInputParamNames("accountID", "nameserverUri", "name").withOutputParamNames("success").implementedAs([this](const std::string& accountID, const std::string& nameserverUri, const std::string& name){ return this->lookupName(accountID, nameserverUri, name); });
        object_.registerMethod("lookupAddress").onInterface(INTERFACE_NAME).withInputParamNames("accountID", "nameserverUri", "address").withOutputParamNames("success").implementedAs([this](const std::string& accountID, const std::string& nameserverUri, const std::string& address){ return this->lookupAddress(accountID, nameserverUri, address); });
        object_.registerMethod("registerName").onInterface(INTERFACE_NAME).withInputParamNames("accountID", "password", "name").withOutputParamNames("success").implementedAs([this](const std::string& accountID, const std::string& password, const std::string& name){ return this->registerName(accountID, password, name); });
        object_.registerMethod("searchUser").onInterface(INTERFACE_NAME).withInputParamNames("accountID", "query").withOutputParamNames("success").implementedAs([this](const std::string& accountID, const std::string& query){ return this->searchUser(accountID, query); });
        object_.registerMethod("setAccountsOrder").onInterface(INTERFACE_NAME).withInputParamNames("order").implementedAs([this](const std::string& order){ return this->setAccountsOrder(order); });
        object_.registerMethod("removeAccount").onInterface(INTERFACE_NAME).withInputParamNames("accoundID").implementedAs([this](const std::string& accoundID){ return this->removeAccount(accoundID); });
        object_.registerMethod("getAccountList").onInterface(INTERFACE_NAME).withOutputParamNames("list").implementedAs([this](){ return this->getAccountList(); });
        object_.registerMethod("registerAllAccounts").onInterface(INTERFACE_NAME).implementedAs([this](){ return this->registerAllAccounts(); });
        object_.registerMethod("sendRegister").onInterface(INTERFACE_NAME).withInputParamNames("accountID", "enable").implementedAs([this](const std::string& accountID, const bool& enable){ return this->sendRegister(accountID, enable); });
        object_.registerMethod("sendTextMessage").onInterface(INTERFACE_NAME).withInputParamNames("accountID", "to", "payloads", "flag").withOutputParamNames("id").implementedAs([this](const std::string& accountID, const std::string& to, const std::map<std::string, std::string>& payloads, const int32_t& flag){ return this->sendTextMessage(accountID, to, payloads, flag); });
        object_.registerMethod("cancelMessage").onInterface(INTERFACE_NAME).withInputParamNames("accountID", "id").withOutputParamNames("success").implementedAs([this](const std::string& accountID, const uint64_t& id){ return this->cancelMessage(accountID, id); });
        object_.registerMethod("getLastMessages").onInterface(INTERFACE_NAME).withInputParamNames("accountID", "base_timestamp").withOutputParamNames("messages").implementedAs([this](const std::string& accountID, const uint64_t& base_timestamp){ return this->getLastMessages(accountID, base_timestamp); });
        object_.registerMethod("getNearbyPeers").onInterface(INTERFACE_NAME).withInputParamNames("accountID").withOutputParamNames("result").implementedAs([this](const std::string& accountID){ return this->getNearbyPeers(accountID); });
        object_.registerMethod("getMessageStatus").onInterface(INTERFACE_NAME).withInputParamNames("id").withOutputParamNames("status").implementedAs([this](const uint64_t& id){ return this->getMessageStatus(id); });
        object_.registerMethod("setIsComposing").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "conversationUri", "isComposing").implementedAs([this](const std::string& accountId, const std::string& conversationUri, const bool& isComposing){ return this->setIsComposing(accountId, conversationUri, isComposing); });
        object_.registerMethod("setMessageDisplayed").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "conversationUri", "messageId", "status").withOutputParamNames("success").implementedAs([this](const std::string& accountId, const std::string& conversationUri, const std::string& messageId, const int32_t& status){ return this->setMessageDisplayed(accountId, conversationUri, messageId, status); });
        object_.registerMethod("setVolume").onInterface(INTERFACE_NAME).withInputParamNames("device", "value").implementedAs([this](const std::string& device, const double& value){ return this->setVolume(device, value); });
        object_.registerMethod("getVolume").onInterface(INTERFACE_NAME).withInputParamNames("device").withOutputParamNames("value").implementedAs([this](const std::string& device){ return this->getVolume(device); });
        object_.registerMethod("muteDtmf").onInterface(INTERFACE_NAME).withInputParamNames("mute").implementedAs([this](const bool& mute){ return this->muteDtmf(mute); });
        object_.registerMethod("isDtmfMuted").onInterface(INTERFACE_NAME).withOutputParamNames("muted").implementedAs([this](){ return this->isDtmfMuted(); });
        object_.registerMethod("muteCapture").onInterface(INTERFACE_NAME).withInputParamNames("mute").implementedAs([this](const bool& mute){ return this->muteCapture(mute); });
        object_.registerMethod("isCaptureMuted").onInterface(INTERFACE_NAME).withOutputParamNames("muted").implementedAs([this](){ return this->isCaptureMuted(); });
        object_.registerMethod("mutePlayback").onInterface(INTERFACE_NAME).withInputParamNames("mute").implementedAs([this](const bool& mute){ return this->mutePlayback(mute); });
        object_.registerMethod("isPlaybackMuted").onInterface(INTERFACE_NAME).withOutputParamNames("muted").implementedAs([this](){ return this->isPlaybackMuted(); });
        object_.registerMethod("muteRingtone").onInterface(INTERFACE_NAME).withInputParamNames("mute").implementedAs([this](const bool& mute){ return this->muteRingtone(mute); });
        object_.registerMethod("isRingtoneMuted").onInterface(INTERFACE_NAME).withOutputParamNames("muted").implementedAs([this](){ return this->isRingtoneMuted(); });
        object_.registerMethod("getAudioManager").onInterface(INTERFACE_NAME).withOutputParamNames("api").implementedAs([this](){ return this->getAudioManager(); });
        object_.registerMethod("setAudioManager").onInterface(INTERFACE_NAME).withInputParamNames("api").withOutputParamNames("successful").implementedAs([this](const std::string& api){ return this->setAudioManager(api); });
        object_.registerMethod("getSupportedAudioManagers").onInterface(INTERFACE_NAME).withOutputParamNames("api").implementedAs([this](){ return this->getSupportedAudioManagers(); });
        object_.registerMethod("getRecordPath").onInterface(INTERFACE_NAME).withOutputParamNames("rec").implementedAs([this](){ return this->getRecordPath(); });
        object_.registerMethod("setRecordPath").onInterface(INTERFACE_NAME).withInputParamNames("rec").implementedAs([this](const std::string& rec){ return this->setRecordPath(rec); });
        object_.registerMethod("getIsAlwaysRecording").onInterface(INTERFACE_NAME).withOutputParamNames("res").implementedAs([this](){ return this->getIsAlwaysRecording(); });
        object_.registerMethod("setIsAlwaysRecording").onInterface(INTERFACE_NAME).withInputParamNames("enabled").implementedAs([this](const bool& enabled){ return this->setIsAlwaysRecording(enabled); });
        object_.registerMethod("getRecordPreview").onInterface(INTERFACE_NAME).withOutputParamNames("res").implementedAs([this](){ return this->getRecordPreview(); });
        object_.registerMethod("setRecordPreview").onInterface(INTERFACE_NAME).withInputParamNames("enabled").implementedAs([this](const bool& enabled){ return this->setRecordPreview(enabled); });
        object_.registerMethod("getRecordQuality").onInterface(INTERFACE_NAME).withOutputParamNames("res").implementedAs([this](){ return this->getRecordQuality(); });
        object_.registerMethod("setRecordQuality").onInterface(INTERFACE_NAME).withInputParamNames("enabled").implementedAs([this](const int32_t& enabled){ return this->setRecordQuality(enabled); });
        object_.registerMethod("getCodecList").onInterface(INTERFACE_NAME).withOutputParamNames("list").implementedAs([this](){ return this->getCodecList(); });
        object_.registerMethod("getCodecDetails").onInterface(INTERFACE_NAME).withInputParamNames("accountID", "codecId").withOutputParamNames("details").implementedAs([this](const std::string& accountID, const uint32_t& codecId){ return this->getCodecDetails(accountID, codecId); });
        object_.registerMethod("setCodecDetails").onInterface(INTERFACE_NAME).withInputParamNames("accountID", "codecId", "details").withOutputParamNames("result").implementedAs([this](const std::string& accountID, const uint32_t& codecId, const std::map<std::string, std::string>& details){ return this->setCodecDetails(accountID, codecId, details); });
        object_.registerMethod("getActiveCodecList").onInterface(INTERFACE_NAME).withInputParamNames("accountID").withOutputParamNames("list").implementedAs([this](const std::string& accountID){ return this->getActiveCodecList(accountID); });
        object_.registerMethod("setActiveCodecList").onInterface(INTERFACE_NAME).withInputParamNames("accountID", "list").implementedAs([this](const std::string& accountID, const std::vector<uint32_t>& list){ return this->setActiveCodecList(accountID, list); });
        object_.registerMethod("getAudioPluginList").onInterface(INTERFACE_NAME).withOutputParamNames("list").implementedAs([this](){ return this->getAudioPluginList(); });
        object_.registerMethod("setAudioPlugin").onInterface(INTERFACE_NAME).withInputParamNames("audioPlugin").implementedAs([this](const std::string& audioPlugin){ return this->setAudioPlugin(audioPlugin); });
        object_.registerMethod("getAudioOutputDeviceList").onInterface(INTERFACE_NAME).withOutputParamNames("list").implementedAs([this](){ return this->getAudioOutputDeviceList(); });
        object_.registerMethod("setAudioOutputDevice").onInterface(INTERFACE_NAME).withInputParamNames("index").implementedAs([this](const int32_t& index){ return this->setAudioOutputDevice(index); });
        object_.registerMethod("setAudioInputDevice").onInterface(INTERFACE_NAME).withInputParamNames("index").implementedAs([this](const int32_t& index){ return this->setAudioInputDevice(index); });
        object_.registerMethod("setAudioRingtoneDevice").onInterface(INTERFACE_NAME).withInputParamNames("index").implementedAs([this](const int32_t& index){ return this->setAudioRingtoneDevice(index); });
        object_.registerMethod("getAudioInputDeviceList").onInterface(INTERFACE_NAME).withOutputParamNames("list").implementedAs([this](){ return this->getAudioInputDeviceList(); });
        object_.registerMethod("getCurrentAudioDevicesIndex").onInterface(INTERFACE_NAME).withOutputParamNames("list").implementedAs([this](){ return this->getCurrentAudioDevicesIndex(); });
        object_.registerMethod("getAudioInputDeviceIndex").onInterface(INTERFACE_NAME).withInputParamNames("devname").withOutputParamNames("index").implementedAs([this](const std::string& devname){ return this->getAudioInputDeviceIndex(devname); });
        object_.registerMethod("getAudioOutputDeviceIndex").onInterface(INTERFACE_NAME).withInputParamNames("devname").withOutputParamNames("index").implementedAs([this](const std::string& devname){ return this->getAudioOutputDeviceIndex(devname); });
        object_.registerMethod("getCurrentAudioOutputPlugin").onInterface(INTERFACE_NAME).withOutputParamNames("plugin").implementedAs([this](){ return this->getCurrentAudioOutputPlugin(); });
        object_.registerMethod("isAudioMeterActive").onInterface(INTERFACE_NAME).withInputParamNames("id").withOutputParamNames("isActive").implementedAs([this](const std::string& id){ return this->isAudioMeterActive(id); });
        object_.registerMethod("setAudioMeterState").onInterface(INTERFACE_NAME).withInputParamNames("id", "state").implementedAs([this](const std::string& id, const bool& state){ return this->setAudioMeterState(id, state); });
        object_.registerMethod("getNoiseSuppressState").onInterface(INTERFACE_NAME).withOutputParamNames("state").implementedAs([this](){ return this->getNoiseSuppressState(); });
        object_.registerMethod("setNoiseSuppressState").onInterface(INTERFACE_NAME).withInputParamNames("state").implementedAs([this](const std::string& state){ return this->setNoiseSuppressState(state); });
        object_.registerMethod("isAgcEnabled").onInterface(INTERFACE_NAME).withOutputParamNames("enabled").implementedAs([this](){ return this->isAgcEnabled(); });
        object_.registerMethod("setAgcState").onInterface(INTERFACE_NAME).withInputParamNames("enabled").implementedAs([this](const bool& enabled){ return this->setAgcState(enabled); });
        object_.registerMethod("getHistoryLimit").onInterface(INTERFACE_NAME).withOutputParamNames("days").implementedAs([this](){ return this->getHistoryLimit(); });
        object_.registerMethod("setHistoryLimit").onInterface(INTERFACE_NAME).withInputParamNames("days").implementedAs([this](const int32_t& days){ return this->setHistoryLimit(days); });
        object_.registerMethod("getRingingTimeout").onInterface(INTERFACE_NAME).withOutputParamNames("timeout").implementedAs([this](){ return this->getRingingTimeout(); });
        object_.registerMethod("setRingingTimeout").onInterface(INTERFACE_NAME).withInputParamNames("timeout").implementedAs([this](const int32_t& timeout){ return this->setRingingTimeout(timeout); });
        object_.registerMethod("getSupportedTlsMethod").onInterface(INTERFACE_NAME).withOutputParamNames("list").implementedAs([this](){ return this->getSupportedTlsMethod(); });
        object_.registerMethod("getSupportedCiphers").onInterface(INTERFACE_NAME).withInputParamNames("accountID").withOutputParamNames("list").implementedAs([this](const std::string& accountID){ return this->getSupportedCiphers(accountID); });
        object_.registerMethod("validateCertificate").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "certificate").withOutputParamNames("details").implementedAs([this](const std::string& accountId, const std::string& certificate){ return this->validateCertificate(accountId, certificate); });
        object_.registerMethod("validateCertificatePath").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "certificatePath", "privateKeyPath", "privateKeyPasswd", "caListPath").withOutputParamNames("details").implementedAs([this](const std::string& accountId, const std::string& certificatePath, const std::string& privateKeyPath, const std::string& privateKeyPasswd, const std::string& caListPath){ return this->validateCertificatePath(accountId, certificatePath, privateKeyPath, privateKeyPasswd, caListPath); });
        object_.registerMethod("getCertificateDetails").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "certificate").withOutputParamNames("details").implementedAs([this](const std::string& accountId, const std::string& certificate){ return this->getCertificateDetails(accountId, certificate); });
        object_.registerMethod("getCertificateDetailsPath").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "certificatePath", "privateKeyPath", "privateKeyPasswd").withOutputParamNames("details").implementedAs([this](const std::string& accountId, const std::string& certificatePath, const std::string& privateKeyPath, const std::string& privateKeyPasswd){ return this->getCertificateDetailsPath(accountId, certificatePath, privateKeyPath, privateKeyPasswd); });
        object_.registerMethod("getPinnedCertificates").onInterface(INTERFACE_NAME).withInputParamNames("accountId").withOutputParamNames("certIds").implementedAs([this](const std::string& accountId){ return this->getPinnedCertificates(accountId); });
        object_.registerMethod("pinCertificate").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "certificateRaw", "local").withOutputParamNames("certId").implementedAs([this](const std::string& accountId, const std::vector<uint8_t>& certificateRaw, const bool& local){ return this->pinCertificate(accountId, certificateRaw, local); });
        object_.registerMethod("unpinCertificate").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "certId").withOutputParamNames("success").implementedAs([this](const std::string& accountId, const std::string& certId){ return this->unpinCertificate(accountId, certId); });
        object_.registerMethod("pinCertificatePath").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "certPath").implementedAs([this](const std::string& accountId, const std::string& certPath){ return this->pinCertificatePath(accountId, certPath); });
        object_.registerMethod("unpinCertificatePath").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "certPath").withOutputParamNames("unpinned").implementedAs([this](const std::string& accountId, const std::string& certPath){ return this->unpinCertificatePath(accountId, certPath); });
        object_.registerMethod("pinRemoteCertificate").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "certId").withOutputParamNames("success").implementedAs([this](const std::string& accountId, const std::string& certId){ return this->pinRemoteCertificate(accountId, certId); });
        object_.registerMethod("setCertificateStatus").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "certId", "status").withOutputParamNames("success").implementedAs([this](const std::string& accountId, const std::string& certId, const std::string& status){ return this->setCertificateStatus(accountId, certId, status); });
        object_.registerMethod("getCertificatesByStatus").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "status").withOutputParamNames("list").implementedAs([this](const std::string& accountId, const std::string& status){ return this->getCertificatesByStatus(accountId, status); });
        object_.registerMethod("getTrustRequests").onInterface(INTERFACE_NAME).withInputParamNames("accountID").withOutputParamNames("requests").implementedAs([this](const std::string& accountID){ return this->getTrustRequests(accountID); });
        object_.registerMethod("acceptTrustRequest").onInterface(INTERFACE_NAME).withInputParamNames("accountID", "from").withOutputParamNames("success").implementedAs([this](const std::string& accountID, const std::string& from){ return this->acceptTrustRequest(accountID, from); });
        object_.registerMethod("discardTrustRequest").onInterface(INTERFACE_NAME).withInputParamNames("accountID", "from").withOutputParamNames("success").implementedAs([this](const std::string& accountID, const std::string& from){ return this->discardTrustRequest(accountID, from); });
        object_.registerMethod("sendTrustRequest").onInterface(INTERFACE_NAME).withInputParamNames("accountID", "to", "payload").implementedAs([this](const std::string& accountID, const std::string& to, const std::vector<uint8_t>& payload){ return this->sendTrustRequest(accountID, to, payload); });
        object_.registerMethod("addContact").onInterface(INTERFACE_NAME).withInputParamNames("accountID", "uri").implementedAs([this](const std::string& accountID, const std::string& uri){ return this->addContact(accountID, uri); });
        object_.registerMethod("removeContact").onInterface(INTERFACE_NAME).withInputParamNames("accountID", "uri", "ban").implementedAs([this](const std::string& accountID, const std::string& uri, const bool& ban){ return this->removeContact(accountID, uri, ban); });
        object_.registerMethod("getContactDetails").onInterface(INTERFACE_NAME).withInputParamNames("accountID", "uri").withOutputParamNames("contactDetails").implementedAs([this](const std::string& accountID, const std::string& uri){ return this->getContactDetails(accountID, uri); });
        object_.registerMethod("getContacts").onInterface(INTERFACE_NAME).withInputParamNames("accountID").withOutputParamNames("contacts").implementedAs([this](const std::string& accountID){ return this->getContacts(accountID); });
        object_.registerMethod("getAddrFromInterfaceName").onInterface(INTERFACE_NAME).withInputParamNames("interface").withOutputParamNames("address").implementedAs([this](const std::string& interface){ return this->getAddrFromInterfaceName(interface); });
        object_.registerMethod("getAllIpInterface").onInterface(INTERFACE_NAME).withOutputParamNames("list").implementedAs([this](){ return this->getAllIpInterface(); });
        object_.registerMethod("getAllIpInterfaceByName").onInterface(INTERFACE_NAME).withOutputParamNames("list").implementedAs([this](){ return this->getAllIpInterfaceByName(); });
        object_.registerMethod("sendFile").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "conversationId", "filePath", "fileDisplayName", "replyTo").implementedAs([this](const std::string& accountId, const std::string& conversationId, const std::string& filePath, const std::string& fileDisplayName, const std::string& replyTo){ return this->sendFile(accountId, conversationId, filePath, fileDisplayName, replyTo); });
        object_.registerMethod("fileTransferInfo").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "to", "fileId").withOutputParamNames("dataTransferError", "path", "totalSize", "bytesProgress").implementedAs([this](const std::string& accountId, const std::string& to, const std::string& fileId){ return this->fileTransferInfo(accountId, to, fileId); });
        object_.registerMethod("downloadFile").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "conversationId", "interactionId", "fileId", "path").withOutputParamNames("result").implementedAs([this](const std::string& accountId, const std::string& conversationId, const std::string& interactionId, const std::string& fileId, const std::string& path){ return this->downloadFile(accountId, conversationId, interactionId, fileId, path); });
        object_.registerMethod("cancelDataTransfer").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "to", "fileId").withOutputParamNames("dataTransferError").implementedAs([this](const std::string& accountId, const std::string& to, const std::string& fileId){ return this->cancelDataTransfer(accountId, to, fileId); });
        object_.registerMethod("monitor").onInterface(INTERFACE_NAME).withInputParamNames("continuous").implementedAs([this](const bool& continuous){ return this->monitor(continuous); });
        object_.registerMethod("getConnectionList").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "conversationId").withOutputParamNames("connections").implementedAs([this](const std::string& accountId, const std::string& conversationId){ return this->getConnectionList(accountId, conversationId); });
        object_.registerMethod("getChannelList").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "connectionId").withOutputParamNames("connections").implementedAs([this](const std::string& accountId, const std::string& connectionId){ return this->getChannelList(accountId, connectionId); });
        object_.registerMethod("startConversation").onInterface(INTERFACE_NAME).withInputParamNames("accountId").withOutputParamNames("conversationId").implementedAs([this](const std::string& accountId){ return this->startConversation(accountId); });
        object_.registerMethod("acceptConversationRequest").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "conversationId").implementedAs([this](const std::string& accountId, const std::string& conversationId){ return this->acceptConversationRequest(accountId, conversationId); });
        object_.registerMethod("declineConversationRequest").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "conversationId").implementedAs([this](const std::string& accountId, const std::string& conversationId){ return this->declineConversationRequest(accountId, conversationId); });
        object_.registerMethod("removeConversation").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "conversationId").withOutputParamNames("success").implementedAs([this](const std::string& accountId, const std::string& conversationId){ return this->removeConversation(accountId, conversationId); });
        object_.registerMethod("getConversations").onInterface(INTERFACE_NAME).withInputParamNames("accountId").withOutputParamNames("conversations").implementedAs([this](const std::string& accountId){ return this->getConversations(accountId); });
        object_.registerMethod("getActiveCalls").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "conversationId").withOutputParamNames("activeCalls").implementedAs([this](const std::string& accountId, const std::string& conversationId){ return this->getActiveCalls(accountId, conversationId); });
        object_.registerMethod("getConversationRequests").onInterface(INTERFACE_NAME).withInputParamNames("accountId").withOutputParamNames("conversations").implementedAs([this](const std::string& accountId){ return this->getConversationRequests(accountId); });
        object_.registerMethod("updateConversationInfos").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "conversationId", "infos").implementedAs([this](const std::string& accountId, const std::string& conversationId, const std::map<std::string, std::string>& infos){ return this->updateConversationInfos(accountId, conversationId, infos); });
        object_.registerMethod("conversationInfos").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "conversationId").withOutputParamNames("infos").implementedAs([this](const std::string& accountId, const std::string& conversationId){ return this->conversationInfos(accountId, conversationId); });
        object_.registerMethod("setConversationPreferences").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "conversationId", "prefs").implementedAs([this](const std::string& accountId, const std::string& conversationId, const std::map<std::string, std::string>& prefs){ return this->setConversationPreferences(accountId, conversationId, prefs); });
        object_.registerMethod("getConversationPreferences").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "conversationId").withOutputParamNames("prefs").implementedAs([this](const std::string& accountId, const std::string& conversationId){ return this->getConversationPreferences(accountId, conversationId); });
        object_.registerMethod("addConversationMember").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "conversationId", "contactUri").implementedAs([this](const std::string& accountId, const std::string& conversationId, const std::string& contactUri){ return this->addConversationMember(accountId, conversationId, contactUri); });
        object_.registerMethod("removeConversationMember").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "conversationId", "contactUri").implementedAs([this](const std::string& accountId, const std::string& conversationId, const std::string& contactUri){ return this->removeConversationMember(accountId, conversationId, contactUri); });
        object_.registerMethod("getConversationMembers").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "conversationId").withOutputParamNames("members").implementedAs([this](const std::string& accountId, const std::string& conversationId){ return this->getConversationMembers(accountId, conversationId); });
        object_.registerMethod("sendMessage").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "conversationId", "message", "commitId", "flag").implementedAs([this](const std::string& accountId, const std::string& conversationId, const std::string& message, const std::string& commitId, const int32_t& flag){ return this->sendMessage(accountId, conversationId, message, commitId, flag); });
        object_.registerMethod("loadConversationMessages").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "conversationId", "fromMessage", "n").withOutputParamNames("id").implementedAs([this](const std::string& accountId, const std::string& conversationId, const std::string& fromMessage, const uint32_t& n){ return this->loadConversationMessages(accountId, conversationId, fromMessage, n); });
        object_.registerMethod("loadConversationUntil").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "conversationId", "fromMessage", "to").withOutputParamNames("id").implementedAs([this](const std::string& accountId, const std::string& conversationId, const std::string& fromMessage, const std::string& to){ return this->loadConversationUntil(accountId, conversationId, fromMessage, to); });
        object_.registerMethod("countInteractions").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "conversationId", "toId", "fromId", "authorUri").withOutputParamNames("count").implementedAs([this](const std::string& accountId, const std::string& conversationId, const std::string& toId, const std::string& fromId, const std::string& authorUri){ return this->countInteractions(accountId, conversationId, toId, fromId, authorUri); });
        object_.registerMethod("searchConversation").onInterface(INTERFACE_NAME).withInputParamNames("accountId", "conversationId", "author", "lastId", "regexSearch", "type", "after", "before", "maxResult", "flag").withOutputParamNames("searchId").implementedAs([this](const std::string& accountId, const std::string& conversationId, const std::string& author, const std::string& lastId, const std::string& regexSearch, const std::string& type, const int64_t& after, const int64_t& before, const uint32_t& maxResult, const int32_t& flag){ return this->searchConversation(accountId, conversationId, author, lastId, regexSearch, type, after, before, maxResult, flag); });
        object_.registerMethod("connectivityChanged").onInterface(INTERFACE_NAME).implementedAs([this](){ return this->connectivityChanged(); });
        object_.registerMethod("setDefaultModerator").onInterface(INTERFACE_NAME).withInputParamNames("accountID", "peerURI", "state").implementedAs([this](const std::string& accountID, const std::string& peerURI, const bool& state){ return this->setDefaultModerator(accountID, peerURI, state); });
        object_.registerMethod("getDefaultModerators").onInterface(INTERFACE_NAME).withInputParamNames("accountID").withOutputParamNames("list").implementedAs([this](const std::string& accountID){ return this->getDefaultModerators(accountID); });
        object_.registerMethod("enableLocalModerators").onInterface(INTERFACE_NAME).withInputParamNames("accountID", "isModEnabled").implementedAs([this](const std::string& accountID, const bool& isModEnabled){ return this->enableLocalModerators(accountID, isModEnabled); });
        object_.registerMethod("isLocalModeratorsEnabled").onInterface(INTERFACE_NAME).withInputParamNames("accountID").withOutputParamNames("isModEnabled").implementedAs([this](const std::string& accountID){ return this->isLocalModeratorsEnabled(accountID); });
        object_.registerMethod("setAllModerators").onInterface(INTERFACE_NAME).withInputParamNames("accountID", "allModerators").implementedAs([this](const std::string& accountID, const bool& allModerators){ return this->setAllModerators(accountID, allModerators); });
        object_.registerMethod("isAllModerators").onInterface(INTERFACE_NAME).withInputParamNames("accountID").withOutputParamNames("allModerators").implementedAs([this](const std::string& accountID){ return this->isAllModerators(accountID); });
        object_.registerSignal("exportOnRingEnded").onInterface(INTERFACE_NAME).withParameters<std::string, int32_t, std::string>("accountID", "status", "PIN");
        object_.registerSignal("deviceRevocationEnded").onInterface(INTERFACE_NAME).withParameters<std::string, std::string, int32_t>("accountID", "deviceId", "status");
        object_.registerSignal("accountProfileReceived").onInterface(INTERFACE_NAME).withParameters<std::string, std::string, std::string>("accountID", "displayName", "photo");
        object_.registerSignal("knownDevicesChanged").onInterface(INTERFACE_NAME).withParameters<std::string, std::map<std::string, std::string>>("accountID", "devices");
        object_.registerSignal("registeredNameFound").onInterface(INTERFACE_NAME).withParameters<std::string, int32_t, std::string, std::string>("accountID", "status", "address", "name");
        object_.registerSignal("nameRegistrationEnded").onInterface(INTERFACE_NAME).withParameters<std::string, int32_t, std::string>("accountID", "status", "name");
        object_.registerSignal("userSearchEnded").onInterface(INTERFACE_NAME).withParameters<std::string, int32_t, std::string, std::vector<std::map<std::string, std::string>>>("accountID", "status", "query", "result");
        object_.registerSignal("incomingAccountMessage").onInterface(INTERFACE_NAME).withParameters<std::string, std::string, std::string, std::map<std::string, std::string>>("accountID", "messageID", "from", "payloads");
        object_.registerSignal("accountMessageStatusChanged").onInterface(INTERFACE_NAME).withParameters<std::string, std::string, std::string, std::string, int32_t>("accountID", "conversationId", "peer", "id", "status");
        object_.registerSignal("needsHost").onInterface(INTERFACE_NAME).withParameters<std::string, std::string>("accountId", "conversationId");
        object_.registerSignal("activeCallsChanged").onInterface(INTERFACE_NAME).withParameters<std::string, std::string, std::vector<std::map<std::string, std::string>>>("accountId", "conversationId", "activeCalls");
        object_.registerSignal("profileReceived").onInterface(INTERFACE_NAME).withParameters<std::string, std::string, std::string>("accountID", "from", "path");
        object_.registerSignal("composingStatusChanged").onInterface(INTERFACE_NAME).withParameters<std::string, std::string, std::string, int32_t>("accountId", "conversationId", "contactId", "status");
        object_.registerSignal("volumeChanged").onInterface(INTERFACE_NAME).withParameters<std::string, double>("device", "value");
        object_.registerSignal("hardwareDecodingChanged").onInterface(INTERFACE_NAME).withParameters<bool>("state");
        object_.registerSignal("hardwareEncodingChanged").onInterface(INTERFACE_NAME).withParameters<bool>("state");
        object_.registerSignal("audioDeviceEvent").onInterface(INTERFACE_NAME);
        object_.registerSignal("audioMeter").onInterface(INTERFACE_NAME).withParameters<std::string, double>("id", "level");
        object_.registerSignal("accountsChanged").onInterface(INTERFACE_NAME);
        object_.registerSignal("accountDetailsChanged").onInterface(INTERFACE_NAME).withParameters<std::string, std::map<std::string, std::string>>("accountID", "details");
        object_.registerSignal("registrationStateChanged").onInterface(INTERFACE_NAME).withParameters<std::string, std::string, int32_t, std::string>("accountID", "registrationState", "registrationDetail", "registrationDetailStr");
        object_.registerSignal("volatileAccountDetailsChanged").onInterface(INTERFACE_NAME).withParameters<std::string, std::map<std::string, std::string>>("accountID", "details");
        object_.registerSignal("stunStatusFailure").onInterface(INTERFACE_NAME).withParameters<std::string>("reason");
        object_.registerSignal("errorAlert").onInterface(INTERFACE_NAME).withParameters<int32_t>("code");
        object_.registerSignal("certificateStateChanged").onInterface(INTERFACE_NAME).withParameters<std::string, std::string, std::string>("accountId", "certId", "state");
        object_.registerSignal("certificatePinned").onInterface(INTERFACE_NAME).withParameters<std::string>("certId");
        object_.registerSignal("certificatePathPinned").onInterface(INTERFACE_NAME).withParameters<std::string, std::vector<std::string>>("path", "certIds");
        object_.registerSignal("certificateExpired").onInterface(INTERFACE_NAME).withParameters<std::string>("certId");
        object_.registerSignal("incomingTrustRequest").onInterface(INTERFACE_NAME).withParameters<std::string, std::string, std::string, std::vector<uint8_t>, uint64_t>("accountID", "conversationId", "from", "payload", "receiveTime");
        object_.registerSignal("contactAdded").onInterface(INTERFACE_NAME).withParameters<std::string, std::string, bool>("accountID", "uri", "confirmed");
        object_.registerSignal("contactRemoved").onInterface(INTERFACE_NAME).withParameters<std::string, std::string, bool>("accountID", "uri", "banned");
        object_.registerSignal("mediaParametersChanged").onInterface(INTERFACE_NAME).withParameters<std::string>("accountID");
        object_.registerSignal("migrationEnded").onInterface(INTERFACE_NAME).withParameters<std::string, std::string>("accountID", "result");
        object_.registerSignal("dataTransferEvent").onInterface(INTERFACE_NAME).withParameters<std::string, std::string, std::string, std::string, int32_t>("accountId", "conversationId", "interactionId", "fileId", "code");
        object_.registerSignal("conversationLoaded").onInterface(INTERFACE_NAME).withParameters<uint32_t, std::string, std::string, std::vector<std::map<std::string, std::string>>>("id", "account_id", "conversation_id", "messages");
        object_.registerSignal("messagesFound").onInterface(INTERFACE_NAME).withParameters<uint32_t, std::string, std::string, std::vector<std::map<std::string, std::string>>>("id", "account_id", "conversation_id", "messages");
        object_.registerSignal("messageReceived").onInterface(INTERFACE_NAME).withParameters<std::string, std::string, std::map<std::string, std::string>>("account_id", "conversation_id", "message");
        object_.registerSignal("conversationProfileUpdated").onInterface(INTERFACE_NAME).withParameters<std::string, std::string, std::map<std::string, std::string>>("account_id", "conversation_id", "profile");
        object_.registerSignal("conversationRequestReceived").onInterface(INTERFACE_NAME).withParameters<std::string, std::string, std::map<std::string, std::string>>("account_id", "conversation_id", "metadatas");
        object_.registerSignal("conversationRequestDeclined").onInterface(INTERFACE_NAME).withParameters<std::string, std::string>("account_id", "conversation_id");
        object_.registerSignal("conversationReady").onInterface(INTERFACE_NAME).withParameters<std::string, std::string>("account_id", "conversation_id");
        object_.registerSignal("conversationRemoved").onInterface(INTERFACE_NAME).withParameters<std::string, std::string>("account_id", "conversation_id");
        object_.registerSignal("conversationMemberEvent").onInterface(INTERFACE_NAME).withParameters<std::string, std::string, std::string, int32_t>("account_id", "conversation_id", "member_uri", "event");
        object_.registerSignal("onConversationError").onInterface(INTERFACE_NAME).withParameters<std::string, std::string, uint32_t, std::string>("account_id", "conversation_id", "code", "what");
        object_.registerSignal("conversationPreferencesUpdated").onInterface(INTERFACE_NAME).withParameters<std::string, std::string, std::map<std::string, std::string>>("account_id", "conversation_id", "preferences");
        object_.registerSignal("debugMessageReceived").onInterface(INTERFACE_NAME).withParameters<std::string>("message");
        object_.registerSignal("messageSend").onInterface(INTERFACE_NAME).withParameters<std::string>("message");
    }

    ~ConfigurationManager_adaptor() = default;

public:
    void emitExportOnRingEnded(const std::string& accountID, const int32_t& status, const std::string& PIN)
    {
        object_.emitSignal("exportOnRingEnded").onInterface(INTERFACE_NAME).withArguments(accountID, status, PIN);
    }

    void emitDeviceRevocationEnded(const std::string& accountID, const std::string& deviceId, const int32_t& status)
    {
        object_.emitSignal("deviceRevocationEnded").onInterface(INTERFACE_NAME).withArguments(accountID, deviceId, status);
    }

    void emitAccountProfileReceived(const std::string& accountID, const std::string& displayName, const std::string& photo)
    {
        object_.emitSignal("accountProfileReceived").onInterface(INTERFACE_NAME).withArguments(accountID, displayName, photo);
    }

    void emitKnownDevicesChanged(const std::string& accountID, const std::map<std::string, std::string>& devices)
    {
        object_.emitSignal("knownDevicesChanged").onInterface(INTERFACE_NAME).withArguments(accountID, devices);
    }

    void emitRegisteredNameFound(const std::string& accountID, const int32_t& status, const std::string& address, const std::string& name)
    {
        object_.emitSignal("registeredNameFound").onInterface(INTERFACE_NAME).withArguments(accountID, status, address, name);
    }

    void emitNameRegistrationEnded(const std::string& accountID, const int32_t& status, const std::string& name)
    {
        object_.emitSignal("nameRegistrationEnded").onInterface(INTERFACE_NAME).withArguments(accountID, status, name);
    }

    void emitUserSearchEnded(const std::string& accountID, const int32_t& status, const std::string& query, const std::vector<std::map<std::string, std::string>>& result)
    {
        object_.emitSignal("userSearchEnded").onInterface(INTERFACE_NAME).withArguments(accountID, status, query, result);
    }

    void emitIncomingAccountMessage(const std::string& accountID, const std::string& messageID, const std::string& from, const std::map<std::string, std::string>& payloads)
    {
        object_.emitSignal("incomingAccountMessage").onInterface(INTERFACE_NAME).withArguments(accountID, messageID, from, payloads);
    }

    void emitAccountMessageStatusChanged(const std::string& accountID, const std::string& conversationId, const std::string& peer, const std::string& id, const int32_t& status)
    {
        object_.emitSignal("accountMessageStatusChanged").onInterface(INTERFACE_NAME).withArguments(accountID, conversationId, peer, id, status);
    }

    void emitNeedsHost(const std::string& accountId, const std::string& conversationId)
    {
        object_.emitSignal("needsHost").onInterface(INTERFACE_NAME).withArguments(accountId, conversationId);
    }

    void emitActiveCallsChanged(const std::string& accountId, const std::string& conversationId, const std::vector<std::map<std::string, std::string>>& activeCalls)
    {
        object_.emitSignal("activeCallsChanged").onInterface(INTERFACE_NAME).withArguments(accountId, conversationId, activeCalls);
    }

    void emitProfileReceived(const std::string& accountID, const std::string& from, const std::string& path)
    {
        object_.emitSignal("profileReceived").onInterface(INTERFACE_NAME).withArguments(accountID, from, path);
    }

    void emitComposingStatusChanged(const std::string& accountId, const std::string& conversationId, const std::string& contactId, const int32_t& status)
    {
        object_.emitSignal("composingStatusChanged").onInterface(INTERFACE_NAME).withArguments(accountId, conversationId, contactId, status);
    }

    void emitVolumeChanged(const std::string& device, const double& value)
    {
        object_.emitSignal("volumeChanged").onInterface(INTERFACE_NAME).withArguments(device, value);
    }

    void emitHardwareDecodingChanged(const bool& state)
    {
        object_.emitSignal("hardwareDecodingChanged").onInterface(INTERFACE_NAME).withArguments(state);
    }

    void emitHardwareEncodingChanged(const bool& state)
    {
        object_.emitSignal("hardwareEncodingChanged").onInterface(INTERFACE_NAME).withArguments(state);
    }

    void emitAudioDeviceEvent()
    {
        object_.emitSignal("audioDeviceEvent").onInterface(INTERFACE_NAME);
    }

    void emitAudioMeter(const std::string& id, const double& level)
    {
        object_.emitSignal("audioMeter").onInterface(INTERFACE_NAME).withArguments(id, level);
    }

    void emitAccountsChanged()
    {
        object_.emitSignal("accountsChanged").onInterface(INTERFACE_NAME);
    }

    void emitAccountDetailsChanged(const std::string& accountID, const std::map<std::string, std::string>& details)
    {
        object_.emitSignal("accountDetailsChanged").onInterface(INTERFACE_NAME).withArguments(accountID, details);
    }

    void emitRegistrationStateChanged(const std::string& accountID, const std::string& registrationState, const int32_t& registrationDetail, const std::string& registrationDetailStr)
    {
        object_.emitSignal("registrationStateChanged").onInterface(INTERFACE_NAME).withArguments(accountID, registrationState, registrationDetail, registrationDetailStr);
    }

    void emitVolatileAccountDetailsChanged(const std::string& accountID, const std::map<std::string, std::string>& details)
    {
        object_.emitSignal("volatileAccountDetailsChanged").onInterface(INTERFACE_NAME).withArguments(accountID, details);
    }

    void emitStunStatusFailure(const std::string& reason)
    {
        object_.emitSignal("stunStatusFailure").onInterface(INTERFACE_NAME).withArguments(reason);
    }

    void emitErrorAlert(const int32_t& code)
    {
        object_.emitSignal("errorAlert").onInterface(INTERFACE_NAME).withArguments(code);
    }

    void emitCertificateStateChanged(const std::string& accountId, const std::string& certId, const std::string& state)
    {
        object_.emitSignal("certificateStateChanged").onInterface(INTERFACE_NAME).withArguments(accountId, certId, state);
    }

    void emitCertificatePinned(const std::string& certId)
    {
        object_.emitSignal("certificatePinned").onInterface(INTERFACE_NAME).withArguments(certId);
    }

    void emitCertificatePathPinned(const std::string& path, const std::vector<std::string>& certIds)
    {
        object_.emitSignal("certificatePathPinned").onInterface(INTERFACE_NAME).withArguments(path, certIds);
    }

    void emitCertificateExpired(const std::string& certId)
    {
        object_.emitSignal("certificateExpired").onInterface(INTERFACE_NAME).withArguments(certId);
    }

    void emitIncomingTrustRequest(const std::string& accountID, const std::string& conversationId, const std::string& from, const std::vector<uint8_t>& payload, const uint64_t& receiveTime)
    {
        object_.emitSignal("incomingTrustRequest").onInterface(INTERFACE_NAME).withArguments(accountID, conversationId, from, payload, receiveTime);
    }

    void emitContactAdded(const std::string& accountID, const std::string& uri, const bool& confirmed)
    {
        object_.emitSignal("contactAdded").onInterface(INTERFACE_NAME).withArguments(accountID, uri, confirmed);
    }

    void emitContactRemoved(const std::string& accountID, const std::string& uri, const bool& banned)
    {
        object_.emitSignal("contactRemoved").onInterface(INTERFACE_NAME).withArguments(accountID, uri, banned);
    }

    void emitMediaParametersChanged(const std::string& accountID)
    {
        object_.emitSignal("mediaParametersChanged").onInterface(INTERFACE_NAME).withArguments(accountID);
    }

    void emitMigrationEnded(const std::string& accountID, const std::string& result)
    {
        object_.emitSignal("migrationEnded").onInterface(INTERFACE_NAME).withArguments(accountID, result);
    }

    void emitDataTransferEvent(const std::string& accountId, const std::string& conversationId, const std::string& interactionId, const std::string& fileId, const int32_t& code)
    {
        object_.emitSignal("dataTransferEvent").onInterface(INTERFACE_NAME).withArguments(accountId, conversationId, interactionId, fileId, code);
    }

    void emitConversationLoaded(const uint32_t& id, const std::string& account_id, const std::string& conversation_id, const std::vector<std::map<std::string, std::string>>& messages)
    {
        object_.emitSignal("conversationLoaded").onInterface(INTERFACE_NAME).withArguments(id, account_id, conversation_id, messages);
    }

    void emitMessagesFound(const uint32_t& id, const std::string& account_id, const std::string& conversation_id, const std::vector<std::map<std::string, std::string>>& messages)
    {
        object_.emitSignal("messagesFound").onInterface(INTERFACE_NAME).withArguments(id, account_id, conversation_id, messages);
    }

    void emitMessageReceived(const std::string& account_id, const std::string& conversation_id, const std::map<std::string, std::string>& message)
    {
        object_.emitSignal("messageReceived").onInterface(INTERFACE_NAME).withArguments(account_id, conversation_id, message);
    }

    void emitConversationProfileUpdated(const std::string& account_id, const std::string& conversation_id, const std::map<std::string, std::string>& profile)
    {
        object_.emitSignal("conversationProfileUpdated").onInterface(INTERFACE_NAME).withArguments(account_id, conversation_id, profile);
    }

    void emitConversationRequestReceived(const std::string& account_id, const std::string& conversation_id, const std::map<std::string, std::string>& metadatas)
    {
        object_.emitSignal("conversationRequestReceived").onInterface(INTERFACE_NAME).withArguments(account_id, conversation_id, metadatas);
    }

    void emitConversationRequestDeclined(const std::string& account_id, const std::string& conversation_id)
    {
        object_.emitSignal("conversationRequestDeclined").onInterface(INTERFACE_NAME).withArguments(account_id, conversation_id);
    }

    void emitConversationReady(const std::string& account_id, const std::string& conversation_id)
    {
        object_.emitSignal("conversationReady").onInterface(INTERFACE_NAME).withArguments(account_id, conversation_id);
    }

    void emitConversationRemoved(const std::string& account_id, const std::string& conversation_id)
    {
        object_.emitSignal("conversationRemoved").onInterface(INTERFACE_NAME).withArguments(account_id, conversation_id);
    }

    void emitConversationMemberEvent(const std::string& account_id, const std::string& conversation_id, const std::string& member_uri, const int32_t& event)
    {
        object_.emitSignal("conversationMemberEvent").onInterface(INTERFACE_NAME).withArguments(account_id, conversation_id, member_uri, event);
    }

    void emitOnConversationError(const std::string& account_id, const std::string& conversation_id, const uint32_t& code, const std::string& what)
    {
        object_.emitSignal("onConversationError").onInterface(INTERFACE_NAME).withArguments(account_id, conversation_id, code, what);
    }

    void emitConversationPreferencesUpdated(const std::string& account_id, const std::string& conversation_id, const std::map<std::string, std::string>& preferences)
    {
        object_.emitSignal("conversationPreferencesUpdated").onInterface(INTERFACE_NAME).withArguments(account_id, conversation_id, preferences);
    }

    void emitDebugMessageReceived(const std::string& message)
    {
        object_.emitSignal("debugMessageReceived").onInterface(INTERFACE_NAME).withArguments(message);
    }

    void emitMessageSend(const std::string& message)
    {
        object_.emitSignal("messageSend").onInterface(INTERFACE_NAME).withArguments(message);
    }

private:
    virtual std::map<std::string, std::string> getAccountTemplate(const std::string& accountType) = 0;
    virtual std::map<std::string, std::string> getAccountDetails(const std::string& accountID) = 0;
    virtual std::map<std::string, std::string> getVolatileAccountDetails(const std::string& accountID) = 0;
    virtual void setAccountDetails(const std::string& accountID, const std::map<std::string, std::string>& details) = 0;
    virtual void setAccountActive(const std::string& accountID, const bool& enable) = 0;
    virtual void setCredentials(const std::string& accountID, const std::vector<std::map<std::string, std::string>>& credentialInformation) = 0;
    virtual std::vector<std::map<std::string, std::string>> getCredentials(const std::string& accountID) = 0;
    virtual std::string addAccount(const std::map<std::string, std::string>& details) = 0;
    virtual bool exportOnRing(const std::string& accountID, const std::string& password) = 0;
    virtual bool exportToFile(const std::string& accountID, const std::string& destinationPath, const std::string& password) = 0;
    virtual bool revokeDevice(const std::string& accountID, const std::string& password, const std::string& deviceId) = 0;
    virtual std::map<std::string, std::string> getKnownRingDevices(const std::string& accountID) = 0;
    virtual bool changeAccountPassword(const std::string& accountID, const std::string& oldPassword, const std::string& newPassword) = 0;
    virtual bool lookupName(const std::string& accountID, const std::string& nameserverUri, const std::string& name) = 0;
    virtual bool lookupAddress(const std::string& accountID, const std::string& nameserverUri, const std::string& address) = 0;
    virtual bool registerName(const std::string& accountID, const std::string& password, const std::string& name) = 0;
    virtual bool searchUser(const std::string& accountID, const std::string& query) = 0;
    virtual void setAccountsOrder(const std::string& order) = 0;
    virtual void removeAccount(const std::string& accoundID) = 0;
    virtual std::vector<std::string> getAccountList() = 0;
    virtual void registerAllAccounts() = 0;
    virtual void sendRegister(const std::string& accountID, const bool& enable) = 0;
    virtual uint64_t sendTextMessage(const std::string& accountID, const std::string& to, const std::map<std::string, std::string>& payloads, const int32_t& flag) = 0;
    virtual bool cancelMessage(const std::string& accountID, const uint64_t& id) = 0;
    virtual std::vector<sdbus::Struct<std::string, std::map<std::string, std::string>, uint64_t>> getLastMessages(const std::string& accountID, const uint64_t& base_timestamp) = 0;
    virtual std::map<std::string, std::string> getNearbyPeers(const std::string& accountID) = 0;
    virtual int32_t getMessageStatus(const uint64_t& id) = 0;
    virtual void setIsComposing(const std::string& accountId, const std::string& conversationUri, const bool& isComposing) = 0;
    virtual bool setMessageDisplayed(const std::string& accountId, const std::string& conversationUri, const std::string& messageId, const int32_t& status) = 0;
    virtual void setVolume(const std::string& device, const double& value) = 0;
    virtual double getVolume(const std::string& device) = 0;
    virtual void muteDtmf(const bool& mute) = 0;
    virtual bool isDtmfMuted() = 0;
    virtual void muteCapture(const bool& mute) = 0;
    virtual bool isCaptureMuted() = 0;
    virtual void mutePlayback(const bool& mute) = 0;
    virtual bool isPlaybackMuted() = 0;
    virtual void muteRingtone(const bool& mute) = 0;
    virtual bool isRingtoneMuted() = 0;
    virtual std::string getAudioManager() = 0;
    virtual bool setAudioManager(const std::string& api) = 0;
    virtual std::vector<std::string> getSupportedAudioManagers() = 0;
    virtual std::string getRecordPath() = 0;
    virtual void setRecordPath(const std::string& rec) = 0;
    virtual bool getIsAlwaysRecording() = 0;
    virtual void setIsAlwaysRecording(const bool& enabled) = 0;
    virtual bool getRecordPreview() = 0;
    virtual void setRecordPreview(const bool& enabled) = 0;
    virtual int32_t getRecordQuality() = 0;
    virtual void setRecordQuality(const int32_t& enabled) = 0;
    virtual std::vector<uint32_t> getCodecList() = 0;
    virtual std::map<std::string, std::string> getCodecDetails(const std::string& accountID, const uint32_t& codecId) = 0;
    virtual bool setCodecDetails(const std::string& accountID, const uint32_t& codecId, const std::map<std::string, std::string>& details) = 0;
    virtual std::vector<uint32_t> getActiveCodecList(const std::string& accountID) = 0;
    virtual void setActiveCodecList(const std::string& accountID, const std::vector<uint32_t>& list) = 0;
    virtual std::vector<std::string> getAudioPluginList() = 0;
    virtual void setAudioPlugin(const std::string& audioPlugin) = 0;
    virtual std::vector<std::string> getAudioOutputDeviceList() = 0;
    virtual void setAudioOutputDevice(const int32_t& index) = 0;
    virtual void setAudioInputDevice(const int32_t& index) = 0;
    virtual void setAudioRingtoneDevice(const int32_t& index) = 0;
    virtual std::vector<std::string> getAudioInputDeviceList() = 0;
    virtual std::vector<std::string> getCurrentAudioDevicesIndex() = 0;
    virtual int32_t getAudioInputDeviceIndex(const std::string& devname) = 0;
    virtual int32_t getAudioOutputDeviceIndex(const std::string& devname) = 0;
    virtual std::string getCurrentAudioOutputPlugin() = 0;
    virtual bool isAudioMeterActive(const std::string& id) = 0;
    virtual void setAudioMeterState(const std::string& id, const bool& state) = 0;
    virtual std::string getNoiseSuppressState() = 0;
    virtual void setNoiseSuppressState(const std::string& state) = 0;
    virtual bool isAgcEnabled() = 0;
    virtual void setAgcState(const bool& enabled) = 0;
    virtual int32_t getHistoryLimit() = 0;
    virtual void setHistoryLimit(const int32_t& days) = 0;
    virtual int32_t getRingingTimeout() = 0;
    virtual void setRingingTimeout(const int32_t& timeout) = 0;
    virtual std::vector<std::string> getSupportedTlsMethod() = 0;
    virtual std::vector<std::string> getSupportedCiphers(const std::string& accountID) = 0;
    virtual std::map<std::string, std::string> validateCertificate(const std::string& accountId, const std::string& certificate) = 0;
    virtual std::map<std::string, std::string> validateCertificatePath(const std::string& accountId, const std::string& certificatePath, const std::string& privateKeyPath, const std::string& privateKeyPasswd, const std::string& caListPath) = 0;
    virtual std::map<std::string, std::string> getCertificateDetails(const std::string& accountId, const std::string& certificate) = 0;
    virtual std::map<std::string, std::string> getCertificateDetailsPath(const std::string& accountId, const std::string& certificatePath, const std::string& privateKeyPath, const std::string& privateKeyPasswd) = 0;
    virtual std::vector<std::string> getPinnedCertificates(const std::string& accountId) = 0;
    virtual std::vector<std::string> pinCertificate(const std::string& accountId, const std::vector<uint8_t>& certificateRaw, const bool& local) = 0;
    virtual bool unpinCertificate(const std::string& accountId, const std::string& certId) = 0;
    virtual void pinCertificatePath(const std::string& accountId, const std::string& certPath) = 0;
    virtual uint32_t unpinCertificatePath(const std::string& accountId, const std::string& certPath) = 0;
    virtual bool pinRemoteCertificate(const std::string& accountId, const std::string& certId) = 0;
    virtual bool setCertificateStatus(const std::string& accountId, const std::string& certId, const std::string& status) = 0;
    virtual std::vector<std::string> getCertificatesByStatus(const std::string& accountId, const std::string& status) = 0;
    virtual std::vector<std::map<std::string, std::string>> getTrustRequests(const std::string& accountID) = 0;
    virtual bool acceptTrustRequest(const std::string& accountID, const std::string& from) = 0;
    virtual bool discardTrustRequest(const std::string& accountID, const std::string& from) = 0;
    virtual void sendTrustRequest(const std::string& accountID, const std::string& to, const std::vector<uint8_t>& payload) = 0;
    virtual void addContact(const std::string& accountID, const std::string& uri) = 0;
    virtual void removeContact(const std::string& accountID, const std::string& uri, const bool& ban) = 0;
    virtual std::map<std::string, std::string> getContactDetails(const std::string& accountID, const std::string& uri) = 0;
    virtual std::vector<std::map<std::string, std::string>> getContacts(const std::string& accountID) = 0;
    virtual std::string getAddrFromInterfaceName(const std::string& interface) = 0;
    virtual std::vector<std::string> getAllIpInterface() = 0;
    virtual std::vector<std::string> getAllIpInterfaceByName() = 0;
    virtual void sendFile(const std::string& accountId, const std::string& conversationId, const std::string& filePath, const std::string& fileDisplayName, const std::string& replyTo) = 0;
    virtual std::tuple<uint32_t, std::string, int64_t, int64_t> fileTransferInfo(const std::string& accountId, const std::string& to, const std::string& fileId) = 0;
    virtual bool downloadFile(const std::string& accountId, const std::string& conversationId, const std::string& interactionId, const std::string& fileId, const std::string& path) = 0;
    virtual uint32_t cancelDataTransfer(const std::string& accountId, const std::string& to, const std::string& fileId) = 0;
    virtual void monitor(const bool& continuous) = 0;
    virtual std::vector<std::map<std::string, std::string>> getConnectionList(const std::string& accountId, const std::string& conversationId) = 0;
    virtual std::vector<std::map<std::string, std::string>> getChannelList(const std::string& accountId, const std::string& connectionId) = 0;
    virtual std::string startConversation(const std::string& accountId) = 0;
    virtual void acceptConversationRequest(const std::string& accountId, const std::string& conversationId) = 0;
    virtual void declineConversationRequest(const std::string& accountId, const std::string& conversationId) = 0;
    virtual bool removeConversation(const std::string& accountId, const std::string& conversationId) = 0;
    virtual std::vector<std::string> getConversations(const std::string& accountId) = 0;
    virtual std::vector<std::map<std::string, std::string>> getActiveCalls(const std::string& accountId, const std::string& conversationId) = 0;
    virtual std::vector<std::map<std::string, std::string>> getConversationRequests(const std::string& accountId) = 0;
    virtual void updateConversationInfos(const std::string& accountId, const std::string& conversationId, const std::map<std::string, std::string>& infos) = 0;
    virtual std::map<std::string, std::string> conversationInfos(const std::string& accountId, const std::string& conversationId) = 0;
    virtual void setConversationPreferences(const std::string& accountId, const std::string& conversationId, const std::map<std::string, std::string>& prefs) = 0;
    virtual std::map<std::string, std::string> getConversationPreferences(const std::string& accountId, const std::string& conversationId) = 0;
    virtual void addConversationMember(const std::string& accountId, const std::string& conversationId, const std::string& contactUri) = 0;
    virtual void removeConversationMember(const std::string& accountId, const std::string& conversationId, const std::string& contactUri) = 0;
    virtual std::vector<std::map<std::string, std::string>> getConversationMembers(const std::string& accountId, const std::string& conversationId) = 0;
    virtual void sendMessage(const std::string& accountId, const std::string& conversationId, const std::string& message, const std::string& commitId, const int32_t& flag) = 0;
    virtual uint32_t loadConversationMessages(const std::string& accountId, const std::string& conversationId, const std::string& fromMessage, const uint32_t& n) = 0;
    virtual uint32_t loadConversationUntil(const std::string& accountId, const std::string& conversationId, const std::string& fromMessage, const std::string& to) = 0;
    virtual uint32_t countInteractions(const std::string& accountId, const std::string& conversationId, const std::string& toId, const std::string& fromId, const std::string& authorUri) = 0;
    virtual uint32_t searchConversation(const std::string& accountId, const std::string& conversationId, const std::string& author, const std::string& lastId, const std::string& regexSearch, const std::string& type, const int64_t& after, const int64_t& before, const uint32_t& maxResult, const int32_t& flag) = 0;
    virtual void connectivityChanged() = 0;
    virtual void setDefaultModerator(const std::string& accountID, const std::string& peerURI, const bool& state) = 0;
    virtual std::vector<std::string> getDefaultModerators(const std::string& accountID) = 0;
    virtual void enableLocalModerators(const std::string& accountID, const bool& isModEnabled) = 0;
    virtual bool isLocalModeratorsEnabled(const std::string& accountID) = 0;
    virtual void setAllModerators(const std::string& accountID, const bool& allModerators) = 0;
    virtual bool isAllModerators(const std::string& accountID) = 0;

private:
    sdbus::IObject& object_;
};

}}} // namespaces

#endif
