
/*
 * This file was automatically generated by sdbus-c++-xml2cpp; DO NOT EDIT!
 */

#ifndef __sdbuscpp__dbuspresencemanager_adaptor_h__adaptor__H__
#define __sdbuscpp__dbuspresencemanager_adaptor_h__adaptor__H__

#include <sdbus-c++/sdbus-c++.h>
#include <string>
#include <tuple>

namespace cx {
namespace ring {
namespace Ring {

class PresenceManager_adaptor
{
public:
    static constexpr const char* INTERFACE_NAME = "cx.ring.Ring.PresenceManager";

protected:
    PresenceManager_adaptor(sdbus::IObject& object)
        : object_(object)
    {
        object_.registerMethod("publish").onInterface(INTERFACE_NAME).withInputParamNames("accountID", "status", "note").implementedAs([this](const std::string& accountID, const bool& status, const std::string& note){ return this->publish(accountID, status, note); });
        object_.registerMethod("answerServerRequest").onInterface(INTERFACE_NAME).withInputParamNames("uri", "flag").implementedAs([this](const std::string& uri, const bool& flag){ return this->answerServerRequest(uri, flag); });
        object_.registerMethod("subscribeBuddy").onInterface(INTERFACE_NAME).withInputParamNames("accountID", "uri", "flag").implementedAs([this](const std::string& accountID, const std::string& uri, const bool& flag){ return this->subscribeBuddy(accountID, uri, flag); });
        object_.registerMethod("getSubscriptions").onInterface(INTERFACE_NAME).withInputParamNames("accountID").withOutputParamNames("credentialInformation").implementedAs([this](const std::string& accountID){ return this->getSubscriptions(accountID); });
        object_.registerMethod("setSubscriptions").onInterface(INTERFACE_NAME).withInputParamNames("accountID", "uriList").implementedAs([this](const std::string& accountID, const std::vector<std::string>& uriList){ return this->setSubscriptions(accountID, uriList); });
        object_.registerSignal("newBuddyNotification").onInterface(INTERFACE_NAME).withParameters<std::string, std::string, bool, std::string>("accountID", "buddyUri", "status", "lineStatus");
        object_.registerSignal("nearbyPeerNotification").onInterface(INTERFACE_NAME).withParameters<std::string, std::string, int32_t, std::string>("accountID", "buddyUri", "status", "displayname");
        object_.registerSignal("subscriptionStateChanged").onInterface(INTERFACE_NAME).withParameters<std::string, std::string, bool>("accountID", "buddyUri", "state");
        object_.registerSignal("newServerSubscriptionRequest").onInterface(INTERFACE_NAME).withParameters<std::string>("buddyUri");
        object_.registerSignal("serverError").onInterface(INTERFACE_NAME).withParameters<std::string, std::string, std::string>("accountID", "error", "msg");
    }

    ~PresenceManager_adaptor() = default;

public:
    void emitNewBuddyNotification(const std::string& accountID, const std::string& buddyUri, const bool& status, const std::string& lineStatus)
    {
        object_.emitSignal("newBuddyNotification").onInterface(INTERFACE_NAME).withArguments(accountID, buddyUri, status, lineStatus);
    }

    void emitNearbyPeerNotification(const std::string& accountID, const std::string& buddyUri, const int32_t& status, const std::string& displayname)
    {
        object_.emitSignal("nearbyPeerNotification").onInterface(INTERFACE_NAME).withArguments(accountID, buddyUri, status, displayname);
    }

    void emitSubscriptionStateChanged(const std::string& accountID, const std::string& buddyUri, const bool& state)
    {
        object_.emitSignal("subscriptionStateChanged").onInterface(INTERFACE_NAME).withArguments(accountID, buddyUri, state);
    }

    void emitNewServerSubscriptionRequest(const std::string& buddyUri)
    {
        object_.emitSignal("newServerSubscriptionRequest").onInterface(INTERFACE_NAME).withArguments(buddyUri);
    }

    void emitServerError(const std::string& accountID, const std::string& error, const std::string& msg)
    {
        object_.emitSignal("serverError").onInterface(INTERFACE_NAME).withArguments(accountID, error, msg);
    }

private:
    virtual void publish(const std::string& accountID, const bool& status, const std::string& note) = 0;
    virtual void answerServerRequest(const std::string& uri, const bool& flag) = 0;
    virtual void subscribeBuddy(const std::string& accountID, const std::string& uri, const bool& flag) = 0;
    virtual std::vector<std::map<std::string, std::string>> getSubscriptions(const std::string& accountID) = 0;
    virtual void setSubscriptions(const std::string& accountID, const std::vector<std::string>& uriList) = 0;

private:
    sdbus::IObject& object_;
};

}}} // namespaces

#endif
