
/*
 * This file was automatically generated by sdbus-c++-xml2cpp; DO NOT EDIT!
 */

#ifndef __sdbuscpp__dbusvideomanager_adaptor_h__adaptor__H__
#define __sdbuscpp__dbusvideomanager_adaptor_h__adaptor__H__

#include <sdbus-c++/sdbus-c++.h>
#include <string>
#include <tuple>

namespace cx {
namespace ring {
namespace Ring {

class VideoManager_adaptor
{
public:
    static constexpr const char* INTERFACE_NAME = "cx.ring.Ring.VideoManager";

protected:
    VideoManager_adaptor(sdbus::IObject& object)
        : object_(object)
    {
        object_.registerMethod("getDeviceList").onInterface(INTERFACE_NAME).withOutputParamNames("list").implementedAs([this](){ return this->getDeviceList(); });
        object_.registerMethod("getCapabilities").onInterface(INTERFACE_NAME).withInputParamNames("deviceId").withOutputParamNames("cap").implementedAs([this](const std::string& deviceId){ return this->getCapabilities(deviceId); });
        object_.registerMethod("getSettings").onInterface(INTERFACE_NAME).withInputParamNames("deviceId").withOutputParamNames("map").implementedAs([this](const std::string& deviceId){ return this->getSettings(deviceId); });
        object_.registerMethod("applySettings").onInterface(INTERFACE_NAME).withInputParamNames("deviceId", "settings").implementedAs([this](const std::string& deviceId, const std::map<std::string, std::string>& settings){ return this->applySettings(deviceId, settings); });
        object_.registerMethod("getDefaultDevice").onInterface(INTERFACE_NAME).withOutputParamNames("deviceId").implementedAs([this](){ return this->getDefaultDevice(); });
        object_.registerMethod("setDefaultDevice").onInterface(INTERFACE_NAME).withInputParamNames("deviceId").implementedAs([this](const std::string& deviceId){ return this->setDefaultDevice(deviceId); });
        object_.registerMethod("startLocalMediaRecorder").onInterface(INTERFACE_NAME).withInputParamNames("videoInputId", "filepath").withOutputParamNames("finalPath").implementedAs([this](const std::string& videoInputId, const std::string& filepath){ return this->startLocalMediaRecorder(videoInputId, filepath); });
        object_.registerMethod("stopLocalRecorder").onInterface(INTERFACE_NAME).withInputParamNames("filepath").implementedAs([this](const std::string& filepath){ return this->stopLocalRecorder(filepath); });
        object_.registerMethod("startAudioDevice").onInterface(INTERFACE_NAME).implementedAs([this](){ return this->startAudioDevice(); });
        object_.registerMethod("stopAudioDevice").onInterface(INTERFACE_NAME).implementedAs([this](){ return this->stopAudioDevice(); });
        object_.registerMethod("openVideoInput").onInterface(INTERFACE_NAME).withInputParamNames("inputUri").withOutputParamNames("inputId").implementedAs([this](const std::string& inputUri){ return this->openVideoInput(inputUri); });
        object_.registerMethod("closeVideoInput").onInterface(INTERFACE_NAME).withInputParamNames("inputId").withOutputParamNames("closed").implementedAs([this](const std::string& inputId){ return this->closeVideoInput(inputId); });
        object_.registerMethod("getDecodingAccelerated").onInterface(INTERFACE_NAME).withOutputParamNames("state").implementedAs([this](){ return this->getDecodingAccelerated(); });
        object_.registerMethod("setDecodingAccelerated").onInterface(INTERFACE_NAME).withInputParamNames("state").implementedAs([this](const bool& state){ return this->setDecodingAccelerated(state); });
        object_.registerMethod("getEncodingAccelerated").onInterface(INTERFACE_NAME).withOutputParamNames("state").implementedAs([this](){ return this->getEncodingAccelerated(); });
        object_.registerMethod("setEncodingAccelerated").onInterface(INTERFACE_NAME).withInputParamNames("state").implementedAs([this](const bool& state){ return this->setEncodingAccelerated(state); });
        object_.registerMethod("setDeviceOrientation").onInterface(INTERFACE_NAME).withInputParamNames("deviceId", "angle").implementedAs([this](const std::string& deviceId, const int32_t& angle){ return this->setDeviceOrientation(deviceId, angle); });
        object_.registerMethod("getRenderer").onInterface(INTERFACE_NAME).withInputParamNames("callId").withOutputParamNames("map").implementedAs([this](const std::string& callId){ return this->getRenderer(callId); });
        object_.registerMethod("startShmSink").onInterface(INTERFACE_NAME).withInputParamNames("sinkId", "value").implementedAs([this](const std::string& sinkId, const bool& value){ return this->startShmSink(sinkId, value); });
        object_.registerSignal("deviceEvent").onInterface(INTERFACE_NAME);
        object_.registerSignal("decodingStarted").onInterface(INTERFACE_NAME).withParameters<std::string, std::string, int32_t, int32_t, bool>("id", "shmPath", "width", "height", "isMixer");
        object_.registerSignal("decodingStopped").onInterface(INTERFACE_NAME).withParameters<std::string, std::string, bool>("id", "shmPath", "isMixer");
    }

    ~VideoManager_adaptor() = default;

public:
    void emitDeviceEvent()
    {
        object_.emitSignal("deviceEvent").onInterface(INTERFACE_NAME);
    }

    void emitDecodingStarted(const std::string& id, const std::string& shmPath, const int32_t& width, const int32_t& height, const bool& isMixer)
    {
        object_.emitSignal("decodingStarted").onInterface(INTERFACE_NAME).withArguments(id, shmPath, width, height, isMixer);
    }

    void emitDecodingStopped(const std::string& id, const std::string& shmPath, const bool& isMixer)
    {
        object_.emitSignal("decodingStopped").onInterface(INTERFACE_NAME).withArguments(id, shmPath, isMixer);
    }

private:
    virtual std::vector<std::string> getDeviceList() = 0;
    virtual std::map<std::string, std::map<std::string, std::vector<std::string>>> getCapabilities(const std::string& deviceId) = 0;
    virtual std::map<std::string, std::string> getSettings(const std::string& deviceId) = 0;
    virtual void applySettings(const std::string& deviceId, const std::map<std::string, std::string>& settings) = 0;
    virtual std::string getDefaultDevice() = 0;
    virtual void setDefaultDevice(const std::string& deviceId) = 0;
    virtual std::string startLocalMediaRecorder(const std::string& videoInputId, const std::string& filepath) = 0;
    virtual void stopLocalRecorder(const std::string& filepath) = 0;
    virtual void startAudioDevice() = 0;
    virtual void stopAudioDevice() = 0;
    virtual std::string openVideoInput(const std::string& inputUri) = 0;
    virtual bool closeVideoInput(const std::string& inputId) = 0;
    virtual bool getDecodingAccelerated() = 0;
    virtual void setDecodingAccelerated(const bool& state) = 0;
    virtual bool getEncodingAccelerated() = 0;
    virtual void setEncodingAccelerated(const bool& state) = 0;
    virtual void setDeviceOrientation(const std::string& deviceId, const int32_t& angle) = 0;
    virtual std::map<std::string, std::string> getRenderer(const std::string& callId) = 0;
    virtual void startShmSink(const std::string& sinkId, const bool& value) = 0;

private:
    sdbus::IObject& object_;
};

}}} // namespaces

#endif
